//
//  Spline.hpp
//  Spline_test
//
//  Created by Shaheen Acheche on 05/10/2016.
//  Copyright © 2016 Shaheen Acheche. All rights reserved.
//

#ifndef Spline_hpp
#define Spline_hpp

#include "integrator.hpp"
#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <complex>
#include <ctime>
#include <vector>
#include <gsl/gsl_errno.h>
#include <gsl/gsl_fft_complex.h>
#include "Green.hpp"

typedef std::vector<double> d_vector;
typedef std::complex<double> d_comp;


class Spline{
public:
    Spline();
    void define(d_vector point, d_vector abs);
    void define();
    void define_G_0(Green_function G, double U);
    cd_vector compute_Iw();
    void create_I_tau();
    void get_derive(d_comp pos0, d_comp neg0);
    d_comp get_S10() const;
    d_comp get_SNbeta() const;
    d_comp get_Sp10() const;
    d_comp get_SpNbeta() const;
    d_comp get_Spp10() const;
    d_comp get_SppNbeta() const;
    cd_vector get_Sppp() const;
    cd_vector get_I() const;
    
    
private:
    d_comp S10;
    d_comp SNbeta;
    d_comp Sp10;
    d_comp SpNbeta;
    d_comp Spp10;
    d_comp SppNbeta;
    cd_vector Sppp;
    cd_vector I;
    cd_vector derive;
    Green_function G_0;
    double U;
    bool init;
    
};

#endif /* Spline_hpp */
