//
//  integrator.hpp
//  DMFT-IPT
//
//  Created by Shaheen Acheche on 28/09/2016.
//  Copyright © 2016 Shaheen Acheche. All rights reserved.
//

#ifndef integrator_hpp
#define integrator_hpp

#include <iostream>
#include <stdio.h>
#include <vector>
#include <complex>
#include <fstream>
#include "Green.hpp"
#include "omp.h"
using namespace std;

typedef complex<double> dcomp;
typedef vector<dcomp> cd_vector;
typedef vector<double> d_vector;

class Green_function;

dcomp integrator(dcomp (*f)(double, double, dcomp), double a, double b, double c, double d, dcomp complex, double error = 0.001);
double density(Green_function G);
double density_2ndmethod(double mu, Green_function G,cd_vector denom);


double density_2ndmethod_asymp(double mu, Green_function G,cd_vector denom);
double density_asymp(Green_function G);

double False_pos_get_mu_density(Green_function G, cd_vector denom, double n_target, double mu_guess=0.8);
dcomp Green_1(double x, double y, dcomp res);



dcomp arrond_0(dcomp n);
cd_vector Compute_self(cd_vector I, double U, double n, double mu, double mu0);
cd_vector Init_hyb(double c, cd_vector size);
cd_vector get_Hyb(int iter);
d_vector linspace(double min, double max, int nbr, bool endpoint=false);
double double_occu(cd_vector Self, Green_function G, double n, double U);

cd_vector Matsubara_frequency(double beta, int Nmax, int Nmin);


//d_vector energy_pert(int q);
//dcomp MF_integrator(int q, dcomp res);
//dcomp MF_integrator_2d(int q, dcomp res);

#endif /* integrator_hpp */
